//+------------------------------------------------------------------+
//| DonkeyOscillator.mq4
//| Short term trading indicator
//+------------------------------------------------------------------+
#property copyright "Flaab"
#property link      ""

//---- Properties
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 DarkSlateGray
#property indicator_color4 DarkSlateGray
#property indicator_color5 DodgerBlue
#property indicator_color6 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT

//---- External variables
extern bool   CalculateOnBarClose = true;
extern int    OsPeriod            = 20;
extern int    AvPeriod            = 100;
extern double Gamma               = 1;

//---- Buffers
double FextMapBuffer1[];
double FextMapBuffer2[];
double FextMapBuffer3[];
double FextMapBuffer4[];
double FextMapBuffer5[];
double FextMapBuffer6[];
double FextMapBuffer7[];
double FextMapBuffer8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
{
   // Total buffers
   IndicatorBuffers(8);
   
   // Visible buffers
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0, FextMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1, FextMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,FextMapBuffer3);    
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,FextMapBuffer4);
   SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159); 
   SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,159);    
   
   // Internal
   SetIndexBuffer(4,FextMapBuffer5);  
   SetIndexBuffer(5,FextMapBuffer6);   
   SetIndexBuffer(6,FextMapBuffer7);  
   SetIndexBuffer(7,FextMapBuffer8);       
   
   // My name
   IndicatorShortName("Donkey short term trading test");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   // Start, limit1, etc..
   int start = 0;
   int limit1, limit2;
   int counted_bars = IndicatorCounted();
   
   // nothing else to do?
   if(counted_bars < 0) 
       return(-1);

   // do not check repeated bars
   limit1 = Bars;// - 1 - counted_bars;
   limit2 = Bars;//
   // Check if ignore bar 0
   if(CalculateOnBarClose == true) { start = 1; }
   
   // Iteration from past to present
   for(int pos = limit1 - 1 - counted_bars; pos >= start; pos--)
     {  
      // Median
      double median  = iMA(Symbol(), 0, OsPeriod, 0, MODE_EMA, PRICE_MEDIAN, pos);
      double median1 = iMA(Symbol(), 0, OsPeriod, 0, MODE_EMA, PRICE_MEDIAN, pos+1);
     
      // Difference
      FextMapBuffer8[pos] = median - median1;
      
      // Save current absolute value
      FextMapBuffer7[pos] = MathAbs(FextMapBuffer8[pos]);
      }
      
   for(pos = limit2 - 1 - counted_bars; pos >= start; pos--)
     {  
      // Flat lines
      double flat = iMAOnArray(FextMapBuffer7, Bars, AvPeriod, pos, MODE_EMA, pos);
      FextMapBuffer3[pos] = (flat * Gamma);
      FextMapBuffer4[pos] = 0 - (flat * Gamma);
      
      // Bar open and Close
      double CLOSE = iClose(Symbol(),0, pos);
      double OPEN  = iOpen (Symbol(),0, pos);
      double HIGH  = iHigh (Symbol(),0, pos);
      double LOW   = iLow  (Symbol(),0, pos);
      
      //---- Deceleration
      if(FextMapBuffer8[pos] < FextMapBuffer8[pos+1])
        {
         // This is a red line
         FextMapBuffer2[pos] = FextMapBuffer8[pos];
         FextMapBuffer1[pos] = 0;
         
         // Calculate short-term trend
         if(FextMapBuffer8[pos] < 0)
           {
           if(CLOSE < OPEN) { FextMapBuffer6[pos] = 0; }
           } 
           else 
           if(FextMapBuffer8[pos] > 0 && FextMapBuffer8[pos] < FextMapBuffer3[pos+1])
             {
             if(CLOSE < OPEN) { FextMapBuffer6[pos] = 0; }
             }
         
         //---- Acceleration
         } 
         else 
         if(FextMapBuffer8[pos] > FextMapBuffer8[pos+1])
           {
         
           // This is a blue line
           FextMapBuffer1[pos] = FextMapBuffer8[pos];
           FextMapBuffer2[pos] = 0;
         
           // Calculate short-term trend
           if(FextMapBuffer8[pos] > 0)
             {
             if(CLOSE > OPEN) { FextMapBuffer5[pos] = 0; 
             }
           } 
           else 
           if(FextMapBuffer8[pos] < 0 && FextMapBuffer8[pos] > FextMapBuffer4[pos+1] )
             {
             if(CLOSE > OPEN) { FextMapBuffer5[pos] = 0; 
             }
         }
      }
   }
   
   // Flat lines
   //for(int i = limit1; i >= start; i--)
   //{
   //   // Flat lines
   //   double flat = iMAOnArray(FextMapBuffer7, Bars, AvPeriod, , MaMethod, i);
   //   FextMapBuffer3[i] = (flat * Gamma);
   //   FextMapBuffer4[i] = 0 - (flat * Gamma);
   //}
   return(0);
}
//----
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

